import 'package:forma/model_form.dart';
import 'package:forma/src/element_form/layouts/i_layout.dart';
import 'adapters/string_element_adapter.dart';

class MaterialModelForm<T> extends ModelForm<T> {
  MaterialModelForm(T model, toHash, fromHash, build)
      : super(
            model,
            [
              // Material form adapters
              // Specific type adapters

              // Fallback is primitive adapter
              StringElementAdapter()
            ],
            toHash,
            fromHash,
            build);

  static MaterialModelForm withLayout<T>(
      ILayout layout, T model, toHash, fromHash) {
    return MaterialModelForm<T>(model, toHash, fromHash, layout.layout);
  }
}
