import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:forma/element_form.dart';

void main() {
  group("FormElement tests:", () {
    test("Rebuild method test", () {
      FormElement element = TestElement(initialValue: "Dataa");
      expect(element.rebuild(null), isA<Widget>());
    });

    test("Get widget test", () {
      FormElement element = TestElement(initialValue: "Dataa");
      element.rebuild(null);
      expect(element.widget, isA<Widget>());
    });
  });
}

class TestElement extends FormElement {
  final Key key;
  final String _initialValue;
  TextEditingController _controller;

  @override
  get value => _controller.text;
  set value(dynamic value) => _controller.text = value;

  TestElement({this.key, String initialValue}) : _initialValue = initialValue;

  @override
  Widget build(BuildContext context) {
    return TextFormField(
      key: key,
      controller: _controller,
    );
  }

  @override
  dispose() {
    _controller.dispose();
  }

  @override
  initialize() {
    _controller = TextEditingController(text: _initialValue);
  }
}
